/**
 * @fileoverview fileoverview Zar
 * @example This example demonstrates
 *  how Zar can be used.
 */

/**
 * Zar class constructor for constructing Zar classes.
 * @param {String} stringParam a string parameter
 * @param {Number} numberParam a number parameter
 * @returns {Zar} a Zar instance
 * @throws Error might throw error if revolution fails
 * @see http://en.wikipedia.org/wiki/Tsar
 */
var Zar = exports.Zar = function(stringParam, numberParam) {

    /**
     * Private Property
     */
    var zarInstance = null;

    /**
     * Private Function
     * @param {String} a describing a
     * @param {Number} b describing b
     */
    function zarInstanceFn(a, b) {
        return;
    };

    /**
     * Instance property
     */
    this.zarPrototype = null;

    /**
     * Instance Function
     * @param {Boolean} doSomething param is not visible in function def
     */
    this.instanceFn = function() {};

    /**
     * Ignore this
     * @ignore
     */
    this.ignoreMe = null;

    /**
     * This property shall be deprecated
     * @deprecated don't use this
     */
    this.deprecateMe = null;

    return this;
};

/**
 * A static property
 */
Zar.zarStatic = null;

/**
 * A static function
 * @returns {Boolean} a true or false value
 */
Zar.zarStaticFn = function() { return true; };

/**
 * A prototype function
 */
Zar.prototype.zarPrototypeTwo = function() {

};

/**
 * A Prototype property.
 */
Zar.prototype.zarPrototypeProp = null;s

/**
 * Single defineProperty
 */
Object.defineProperty(Zar, 'zarDefine', {
    value: 'zarDefine',
});

/**
 * DefineProperties with multiple new properties
 */
Object.defineProperties(Zar, {
    /**
     * First property in defineProperties
     * @type Boolean
     */
    'defineMultiOne': {
        value: true,
    },
    /**
     * Second property in defineProperties
     * @type Number
     */
    'defineMultiTwo': {
        value: 123,
    }
});

/**
 * Non exported properties like this one should not show up
 */
function ZarBar() {}

/**
 * Neither should this show up.
 */
var zarDebug = false;
